#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#define DIM 4096

int main(int argc, char** argv){
	int err;
	struct addrinfo hints;
	struct addrinfo *res,*ptr;
	char *host_remoto;
	char *servizio_remoto;
	char *stringa;
	char *nome_file;
	int sd, nread;
	char buf[DIM], ack[10];
	int i=1;
    char *ackVer="ack\n";
    
	
	/* Controllo argomenti */
	if (argc<5){
		printf("Uso: rgrep <server> <porta> <stringa> <nomeFile>...\n");
		exit(1);
	}

	/* Costruzione dell'indirizzo */
	memset(&hints, 0, sizeof(hints));
	hints.ai_family   = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* Risoluzione dell'host */
	host_remoto = argv[1];
	servizio_remoto = argv[2];
	stringa = argv[3];
	nome_file = argv[4];
	
	if ((err = getaddrinfo(host_remoto, servizio_remoto, &hints, &res)) != 0) {
		fprintf(stderr, "Errore risoluzione nome: %s\n", gai_strerror(err));
		exit(2);
	}

	for(ptr = res; ptr != NULL; ptr = ptr->ai_next){
		/*se socket fallisce salto direttamente alla prossima iterazione*/
		if ((sd = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol)) < 0){
			fprintf(stderr,"creazione socket fallita\n");
			continue;
		}
		/*se connect funziona esco dal ciclo*/
		if (connect(sd, ptr->ai_addr, ptr->ai_addrlen) == 0){
			printf("connect riuscita al tentativo %d\n",i);
			break;
		}
		i++;
		close(sd);
	}
	
	/* Verifica sul risultato restituito da getaddrinfo */
	if (ptr == NULL) {
		fprintf(stderr, "Errore risoluzione nome: nessun indirizzo corrispondente trovato\n");
		exit(3);
	}

	/* Liberiamo la memoria allocata da getaddrinfo() */
	freeaddrinfo(res);

	/* Scambio dati */
	
	// mando il nomeFile
	if (write(sd, nome_file, strlen(nome_file) ) < 0) {
		perror("write nome_file");
		exit(6);
	}
    memset(ack, 0, sizeof(ack));
	// cosa succede se il server chiude la socket durante la read?
	if ((nread = read(sd, ack, DIM-1))<0){
		printf("errore lettura ack");
		exit(11);
	}
    
	if (strcmp(ackVer, ack)!=0){
		perror("strcmp ack");
		exit(12);
	}
	
	// mando la stringa	
	if (write(sd, stringa, strlen(stringa))<0){
		perror("scrittura stringa");
		exit(13);
	}

	/* Facciamo lo shutdown della scrittura sulla socket */
	shutdown(sd, SHUT_WR);

	/* Ricezione risultato */

	/* È consigliabile effettuare il flushing del buffer di printf
	 * prima di iniziare a scrivere sullo standard output con write */
	fflush(stdout);
	
	while ((nread = read(sd, buf, DIM)) > 0) {
		if (write(1, buf, nread) < 0) {
			perror("write su stdout");
			exit(9);
		}
	}
	
	/* Controllo errori di lettura */
	if (nread < 0) {
		perror("read dei risultati");
		exit(10);
	}

	close(sd);
	return 0;
}
